package ru.volgait.ftp.client_server;

import ru.volgait.ftp.client_server.command.CommandName;
import ru.volgait.ftp.client_server.command.CommandResult;
import ru.volgait.ftp.client_server.command.Command;

import java.io.*;
import java.net.ServerSocket;
import java.net.Socket;

public class FileServer {

    private String directory;
    private int portNumber;

    public void start() throws IOException {
        System.out.println("Server was started");
        try (
                ServerSocket serverSocket = new ServerSocket(portNumber);
                Socket clientSocket = serverSocket.accept();
                DataOutputStream out =
                        new DataOutputStream(clientSocket.getOutputStream());
                DataInputStream in = new DataInputStream(clientSocket.getInputStream());
        ) {

            String input;
            out.writeUTF("Server was succesfully connected");
            System.out.println("Waiting for user commands...");
            while ((input = in.readUTF()) != null) {
                Command command = getCommandFromInput(input);
                if (command.getName() == CommandName.CLOSE_CONNECTION) {
                    System.exit(1);
                }
                CommandResult executionResult = command.execute();
                out.writeUTF(executionResult.getMessage());
            }
        } catch (IOException exception) {
            System.err.println("Exception was happened during trying listening for connection");
            System.err.println(exception.getMessage());
        }
    }

    public static void main(String[] args) throws IOException {
        if (args.length != 2) {
            System.err.println("Usage: java FileServer <port number> <directory>");
            System.exit(1);
        }
        int portNumber = Integer.parseInt(args[0]);
        String directory = args[1];
        FileServer server = new FileServer(portNumber, directory);
        server.start();
    }

    public FileServer(int portNumber, String directory) {
        this.directory = directory;
        this.portNumber = portNumber;

    }

    private Command getCommandFromInput(String inputLine){
        System.out.println("Proccesing command:" +inputLine);
        return null;
    }
}

