package ru.volgait.ftp.client_server.command;


import ru.volgait.ftp.client_server.exception.WrongCommandException;

public class Command {

    private CommandName name;
    private String[] arguments;

    public Command(CommandName name, String... arguments) {
        this.name = name;
        this.arguments = arguments;
    }
    public Command(String input) throws WrongCommandException {
        if (input == null) {
            throw new WrongCommandException("Command can't be null!!");
        }
        this.name = parseCommandName(input);
        this.arguments = parseArgs(input);
    }
    private static CommandName parseCommandName(String commandWithArgs) throws WrongCommandException {
        String name = commandWithArgs.split(" ")[0];
        if (CommandName.contains(name)) {
            return CommandName.valueOf(name);
        }
        throw new WrongCommandException(name);
    }

    public CommandResult execute() {
        return null;
    }

    public CommandName getName() {
        return name;
    }

    public void setName(CommandName name) {
        this.name = name;
    }

    public String[] getArguments() {
        return arguments;
    }

    public void setArguments(String[] arguments) {
        this.arguments = arguments;
    }

    @Override
    public String toString() {
        String command = "name";
        for (String argument : arguments) {
            command += argument + " ";
        }
        return name + " ";
    }
    private static String[] parseArgs(String commandWithArgs) {
        return new String[]{commandWithArgs.split(" ")[1]};
    }
}
