import java.io.*;
import java.net.ServerSocket;
import java.net.Socket;

public class FTPServer {

    public static final int PORT_NUMBER = 5217;



    public static void main(String args[]) throws Exception {
        if (args.length != 1) {
            System.err.println("Usage: java FTPServer <path to file>");
            System.exit(1);
        }
        ServerSocket socket = new ServerSocket(PORT_NUMBER);
        System.out.println("Server is started on port: "+PORT_NUMBER);
        while (true) {
            System.out.println("Waiting for Connection ...");
            SynchronizeFile t = new SynchronizeFile(socket.accept(),args[0]);
        }
    }
}

class SynchronizeFile extends Thread {

    private DataInputStream dataInputStream;
    private DataOutputStream dataOutputStream;

    private String fileName;

    private long lastModify;

    public SynchronizeFile(Socket soc, String fileName) {
        try {
            this.dataInputStream = new DataInputStream(soc.getInputStream());
            this.dataOutputStream = new DataOutputStream(soc.getOutputStream());
            this.fileName = fileName;
            File file = new File(fileName);
            lastModify = file.lastModified();
            System.out.println("Client is connected ...");
            start();

        } catch (IOException exception) {
            System.err.println("Exception was happened during connection");
            System.err.println(exception.getMessage());
        }
    }

    void sendFile() throws Exception {
        File f = new File(fileName);

        if (!f.exists()) {
            dataOutputStream.writeUTF("File Not Found");
        } else {
            dataOutputStream.writeUTF("Ready");
            dataOutputStream.writeUTF(fileName);

            if (dataInputStream.readBoolean()) {
                boolean wasModified = f.lastModified() != lastModify;
                lastModify = f.lastModified();
                dataOutputStream.writeBoolean(wasModified);
                if (wasModified) {
                    System.out.println("File has last version");
                    return;
                }
            }

            FileInputStream fin = new FileInputStream(f);
            int ch;
            do {
                ch = fin.read();
                dataOutputStream.writeUTF(String.valueOf(ch));
            }
            while (ch != -1);
            dataOutputStream.writeUTF("File was synchronized successfully");
            System.out.println("File was synchronized successfully");
            fin.close();

        }
    }



    public void start() {
        try {
            sendFile();
        } catch (Exception exception) {
            exception.printStackTrace();
        }
    }
}