package ru.volgait.synchronize.client_server;

import java.net.*;
import java.io.*;


class FTPClient {
    public static int PORT_NUMBER = 5217;

    public static void main(String args[]) throws Exception {
        System.out.println("Client is started");

        if (args.length != 2) {
            System.err.println("Usage: FTPClient <host> <path to root dir>");
            System.exit(1);
        }

        String host = args[0];
        String directory = args[1];

        Socket socket = new Socket(host, PORT_NUMBER);
        SynchronizeClientThread t = new SynchronizeClientThread(socket, directory);
        t.start();
    }
}

class SynchronizeClientThread extends Thread {
    private String directory;
    private DataInputStream dIn;
    private DataOutputStream dOut;

    SynchronizeClientThread(Socket soc, String directory) {
        try {
            this.directory = directory;
            dIn = new DataInputStream(soc.getInputStream());
            dOut = new DataOutputStream(soc.getOutputStream());
        } catch (IOException exception) {
            System.err.println("Exception was happened during trying listening for connection");
            System.err.println(exception.getMessage());
        }
    }


    void synchronizeFile() throws Exception {
        String msgFromServer = dIn.readUTF();

        if (msgFromServer.compareTo("File Not Found") == 0) {
            System.out.println("File not found on Server ...");
        } else {
            String serverFileName = dIn.readUTF();
            String fileName = directory + serverFileName.substring(serverFileName.lastIndexOf('\\'));
            File file = new File(fileName);
            if (file.exists()) {
                System.out.println("Checking files...");
                //say server to check files
                dOut.writeBoolean(true);
                boolean wasModified = dIn.readBoolean();

                if (wasModified) {
                    System.out.println("File has last version");
                    return;
                } else {
                    System.out.println("File should be refreshed");
                }
            } else {
                //say server that no version of file on client
                dOut.writeBoolean(false);
                return;
            }

            FileOutputStream fileOutputStream = new FileOutputStream(file);
            int ch;
            String temp;
            do {
                temp = dIn.readUTF();
                ch = Integer.parseInt(temp);
                if (ch != -1) {
                    fileOutputStream.write(ch);
                }
            } while (ch != -1);
            fileOutputStream.close();
            System.out.println(dIn.readUTF());
        }
    }

    public void start() {
        try {
            synchronizeFile();
        } catch (Exception e) {
            e.printStackTrace();
        }
        try {
            dOut.writeUTF("DISCONNECT");
        } catch (IOException e) {
            e.printStackTrace();
        }
        System.exit(1);
    }
}